#!/usr/bin/env python3

from skpy import Skype
from skpy import SkypeEventLoop, SkypeNewMessageEvent

import base64
import importlib
import traceback
import json
import os

# Local import
import handler

CREDENTIALS_FILE = "{}/credentials.json".format(os.path.dirname(__file__))

class State():
    pass

class SkypePing(SkypeEventLoop):
    def __init__(self, username, password):
        self.state = State()
        super(SkypePing, self).__init__(username, password)

    def onEvent(self, event):
        if isinstance(event, SkypeNewMessageEvent) and not event.msg.userId == self.userId:
            try:
                importlib.reload(handler)
                handler.handle(event, self.state)
            except Exception as exc:
                print("EXCEPTION:")
                traceback.print_exc()


if __name__ == '__main__':
    with open(CREDENTIALS_FILE, 'r') as f:
        credentials = json.load(f)
    ping = SkypePing(credentials['username'], credentials['password'])
    print("Go!")
    ping.loop()
